/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: DemoContext.java,v 1.4 2009/08/19 16:50:56 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model;

import com.unitesk.testfusion.core.context.GeneratorContext;
import com.unitesk.testfusion.core.context.RegisterContext;
import com.unitesk.testfusion.core.context.RegisterSet;
import com.unitesk.testfusion.core.model.OperandType;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class DemoContext extends GeneratorContext
{
    protected DemoProcessor processor;
    
    protected boolean[] used =
    {
        /*  0 */ false,
        /*  1 */ false,
        /*  2 */ true,
        /*  3 */ true,
        /*  4 */ true,
        /*  5 */ true,
        /*  6 */ true,
        /*  7 */ true,
        /*  8 */ true,
        /*  9 */ true,
        /* 10 */ true,
        /* 11 */ true,
        /* 12 */ true,
        /* 13 */ true,
        /* 14 */ true,
        /* 15 */ true,
        /* 16 */ true,
        /* 17 */ true,
        /* 18 */ true,
        /* 19 */ true,
        /* 20 */ true,
        /* 21 */ true,
        /* 22 */ true,
        /* 23 */ true,
        /* 24 */ true,
        /* 25 */ true,
        /* 26 */ false,
        /* 27 */ false,
        /* 28 */ true,
        /* 29 */ true,
        /* 30 */ true,
        /* 31 */ true,
    };
    
    public DemoContext(DemoProcessor processor)
    {
        this.processor = processor;
        
        init();
    }

    protected DemoContext(DemoContext r)
    {
        super(r);
    }
    
    protected void init()
    {
        RegisterSet registerSet = new RegisterSet();
        
        for(int i = 0; i < DemoProcessor.REGISTER_FILE_SIZE; i++)
        {
        	if(used[i])
        		{ registerSet.add(processor.getRegister(i)); }
        }
        
        initOperandType(OperandType.REGISTER, registerSet, RegisterContext.SHOULD_NOT_RETURN_USED_REGISTER);
    }
    
    public void reset()
    {
        super.reset();
    }
    
    public DemoContext clone()
    {
        return new DemoContext(this);
    }
}
