/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: DemoProcessor.java,v 1.2 2009/08/06 10:27:44 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model;

import com.unitesk.testfusion.core.model.Processor;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class DemoProcessor extends Processor
{
    public static final int REGISTER_FILE_SIZE = 32;
    
    protected DemoRegister[] registerFile = new DemoRegister[]
    {
        new DemoRegister(0), // Always zero
        new DemoRegister(1),
        new DemoRegister(2),
        new DemoRegister(3),
        new DemoRegister(4),
        new DemoRegister(5),
        new DemoRegister(6),
        new DemoRegister(7),
        new DemoRegister(8),
        new DemoRegister(9),
        new DemoRegister(10),
        new DemoRegister(11),
        new DemoRegister(12),
        new DemoRegister(13),
        new DemoRegister(14),
        new DemoRegister(15),
        new DemoRegister(16),
        new DemoRegister(17),
        new DemoRegister(18),
        new DemoRegister(19),
        new DemoRegister(20),
        new DemoRegister(21),
        new DemoRegister(22),
        new DemoRegister(23),
        new DemoRegister(24),
        new DemoRegister(25),
        new DemoRegister(26),
        new DemoRegister(27),
        new DemoRegister(28),
        new DemoRegister(29),
        new DemoRegister(30),
        new DemoRegister(31)
    };
    
    public DemoProcessor()
    {
        super("Demo");
    }
    
    protected DemoProcessor(DemoProcessor r)
    {
        super(r);

        for(int i = 0; i < REGISTER_FILE_SIZE; i++)
            { registerFile[i] = r.registerFile[i].clone(); }
    }
    
    public DemoRegister getRegister(int i)
    {
        return registerFile[i];
    }
    
    @Override
    public void reset()
    {
        for(int i = 0; i < REGISTER_FILE_SIZE; i++)
            { registerFile[i].reset(); }
    }

    @Override
    public Processor clone()
    {
        return new DemoProcessor(this);
    }
}
