/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: DemoRegister.java,v 1.2 2009/08/18 14:52:37 vorobyev Exp $
 */

package com.unitesk.testfusion.demo.model;

import com.unitesk.testfusion.core.model.register.Register64;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class DemoRegister extends Register64
{
    protected int number;
    
    public DemoRegister(int number)
    {
        this.number = number;
    }
    
    protected DemoRegister(DemoRegister r)
    {
        this.number = r.number;
    }

    @Override
    public boolean equals(Object o)
    {
    	if(!(o instanceof DemoRegister))
    		{ return false; }
    	
    	DemoRegister r = (DemoRegister)o;
    	
    	return r.number == number;
    }
    
    @Override
    public String toString()
    {
    	return "$" + number;
    }
    
    @Override
    public DemoRegister clone()
    {
        return new DemoRegister(this);
    }
}
