/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: DemoGenerator.java,v 1.4 2009/08/14 14:40:52 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model.config;

import com.unitesk.testfusion.core.engine.GeneratorEngine;
import com.unitesk.testfusion.core.engine.Test;
import com.unitesk.testfusion.demo.model.DemoContext;
import com.unitesk.testfusion.demo.model.DemoProcessor;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class DemoGenerator extends GeneratorEngine
{
    protected DemoProcessor processor = new DemoProcessor();
    
    public DemoGenerator(int testSize)
    {
        super(testSize);
        
        DemoContext context = new DemoContext(processor);
        DemoTemplate template = new DemoTemplate(processor, DemoConfig.MAX_BRANCH_NUMBER, DemoConfig.BEQ_TRACE_ARRAY, DemoConfig.MAX_TRACE_LENGTH * DemoConfig.MAX_TEMPLATE_SIZE);
        
        Test test = new Test(processor, context, template, "test", ".S");
        test.setOutputDirectory("tests");
        
        setTargetTest(test);
        addComments(false);
    }
}
