/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: DemoInstruction.java,v 1.1 2009/07/14 12:36:58 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model.isa;

import com.unitesk.testfusion.core.model.Instruction;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public abstract class DemoInstruction extends Instruction
{
    public DemoInstruction(String name)
    {
        super(name);
    }

    @Override
    public boolean doesNullifyDelaySlot()
    {
        return false;
    }

    @Override
    public int getLatency()
    {
        return 1;
    }

    @Override
    public int getRepeat()
    {
        return 1;
    }

    @Override
    public boolean hasDelaySlot()
    {
        return true;
    }

    @Override
    public boolean isBranchInstruction()
    {
        return false;
    }

    @Override
    public boolean isConditionalBranch()
    {
        return false;
    }
}
