/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: DemoSituation.java,v 1.2 2009/08/12 15:17:57 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model.isa;

import com.unitesk.testfusion.core.context.GeneratorContext;
import com.unitesk.testfusion.core.model.Operand;
import com.unitesk.testfusion.core.model.Processor;
import com.unitesk.testfusion.core.model.Program;
import com.unitesk.testfusion.core.situation.RandomSituation;
import com.unitesk.testfusion.core.situation.Situation;
import com.unitesk.testfusion.demo.model.DemoProcessor;
import com.unitesk.testfusion.demo.model.DemoRegister;
import com.unitesk.testfusion.demo.model.lib.LoadImmediate32Program;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class DemoSituation extends RandomSituation
{
    public DemoSituation(String name, String text)
    {
        super(name, text);
    }
    
    protected DemoSituation(DemoSituation r)
    {
        super(r);
    }
    
    @Override
    public Program prepare(Processor processor, GeneratorContext context, int layer)
    {
        int i, size;
        
        Program program = new Program();
        
        size = countOperand();
        for(i = 0; i < size; i++)
        {
            Operand operand = getOperand(i);
            
            if(operand.isImmediate() || !operand.isInput())
                { continue; }
            
            DemoRegister register = (DemoRegister)operand.getRegister();
            
            if(context.isDefinedRegister(register))
                { continue; }
            
            program.append(new LoadImmediate32Program((DemoProcessor)processor, register, operand.getIntegerValue()));
        }
        
        
        return program;
    }

    @Override
    public Situation clone()
    {
        return new DemoSituation(this);
    }
}
