/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: ADDINormalSituation.java,v 1.3 2009/08/13 15:54:29 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model.isa.arithmetic.situation;

import com.unitesk.testfusion.core.context.GeneratorContext;
import com.unitesk.testfusion.core.generator.IntegerArithmetic;
import com.unitesk.testfusion.core.model.Operand;
import com.unitesk.testfusion.core.model.Processor;
import com.unitesk.testfusion.demo.model.isa.DemoSituation;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class ADDINormalSituation extends DemoSituation
{
    public ADDINormalSituation()
    {
        super("Normal", "Produces exceptionless execution of ADDI instruction");
    }
    
    protected ADDINormalSituation(ADDINormalSituation r)
    {
        super(r);
    }
    
    @Override
    public boolean construct(Processor processor, GeneratorContext context)
    {
        Operand rsOperand = getOperand("rs");
        Operand imOperand = getOperand("im");
        
        boolean rsDefined = context.isDefinedRegister(rsOperand.getRegister());
        
        IntegerArithmetic.lhs32 = rsOperand.getIntegerValue();
        
        if(!IntegerArithmetic.add32x16_normal(rsDefined, false))
            { return false; }
        
        rsOperand.setIntegerValue(IntegerArithmetic.lhs32);
        imOperand.setShortValue(IntegerArithmetic.rhs16);
        
        return true;
    }

    @Override
    public ADDINormalSituation clone()
    {
        return new ADDINormalSituation(this);
    }

}
