/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: JInstruction.java,v 1.2 2009/08/06 10:27:52 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model.isa.branch;

import com.unitesk.testfusion.core.model.ContentType;
import com.unitesk.testfusion.core.model.Operand;
import com.unitesk.testfusion.core.model.OperandType;
import com.unitesk.testfusion.core.model.Processor;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class JInstruction extends BranchInstruction
{
    public JInstruction()
    {
        super("j");
        
        registerOperand(new Operand(this, "target", Operand.INPUT,  OperandType.IMMEDIATE, ContentType.OFFSET));
    }
    
    public JInstruction(String label)
    {
        this();
        
        this.label = label;
    }

    @Override
    public void calculate(Processor processor)
    {
        super.calculate(processor);
    }
    
    @Override
    public void execute(Processor processor) 
    {
        super.execute(processor);
    }
 
    @Override
    public boolean isConditionalBranch()
    {
        return false;
    }

    @Override
    public String toString()
    {
        Operand targetOperand = getOperand("target");
        
        return "j " + (label != null ? label : "0x" + Integer.toHexString(targetOperand.getIntegerValue()));
    }
    
    @Override
    public JInstruction createInstruction()
    {
        return new JInstruction();
    }
}
