/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: JTraceSituation.java,v 1.1 2009/07/14 12:37:06 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model.isa.branch.situation;

import com.unitesk.testfusion.core.context.GeneratorContext;
import com.unitesk.testfusion.core.model.Processor;
import com.unitesk.testfusion.core.model.Program;
import com.unitesk.testfusion.core.template.iterator.branch.JumpTraceSituation;
import com.unitesk.testfusion.demo.model.isa.branch.BranchInstruction;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class JTraceSituation extends JumpTraceSituation
{
    public JTraceSituation()
    {
        super("J Trace", "Produces execution trace for J instruction");
    }

    protected JTraceSituation(JTraceSituation r)
    {
        super(r);
    }

    @Override
    public boolean construct(Processor processor, GeneratorContext context)
    {
        BranchInstruction instruction = (BranchInstruction)getInstruction();
        
        instruction.setLabel(getBranchLabel() + (getBranchIndex() >= getBranchLabel() ? "b" : "f"));
        
        return true;
    }

    @Override
    public Program prepare(Processor processor, GeneratorContext context, int layer)
    {
        return new Program();
    }
    
    @Override
    public JTraceSituation clone()
    {
        return new JTraceSituation(this);
    }
}
