/* 
 * Copyright (c) 2007 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: LAInstruction.java,v 1.1 2009/07/14 12:37:08 kamkin Exp $
 */
package com.unitesk.testfusion.demo.model.isa.logic;

import com.unitesk.testfusion.core.model.ContentType;
import com.unitesk.testfusion.core.model.Operand;
import com.unitesk.testfusion.core.model.OperandType;
import com.unitesk.testfusion.core.model.Processor;
import com.unitesk.testfusion.demo.model.DemoRegister;
import com.unitesk.testfusion.demo.model.isa.DemoInstruction;

/**
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public class LAInstruction extends DemoInstruction
{
    protected String label;

    public LAInstruction()
    {
        super("la");
        
        registerOperand(new Operand(this, "rs", Operand.OUTPUT, OperandType.REGISTER, ContentType.WORD));
    }

    public LAInstruction(DemoRegister rs, String label)
    {
        this();
        
        Operand rsOperand = getOperand("rs");
        rsOperand.setRegister(rs);
        
        this.label = label;
    }

    @Override
    public void calculate(Processor processor) 
    {
        super.calculate(processor);
    }
    
    @Override
    public void execute(Processor processor) 
    {
        super.execute(processor);
    }

    @Override
    public String toString()
    {
        Operand rsOperand = getOperand("rs");

        return "la " + rsOperand.getRegister() + ", " + this.label;
    }
    
    @Override
    public LAInstruction createInstruction()
    {
        return new LAInstruction();
    }
    
}
