package com.unitesk.testfusion.demo.model.isa.system;

import com.unitesk.testfusion.core.model.ContentType;
import com.unitesk.testfusion.core.model.Instruction;
import com.unitesk.testfusion.core.model.Operand;
import com.unitesk.testfusion.core.model.OperandType;
import com.unitesk.testfusion.core.model.Processor;
import com.unitesk.testfusion.demo.model.isa.DemoInstruction;

/**
 * @author <a href="emailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class WAITInstruction extends DemoInstruction
{
    public WAITInstruction()
    {
        super("wait");
        
        registerOperand(new Operand(this, "code", Operand.INPUT, OperandType.IMMEDIATE, ContentType.HALF_WORD));
    }

    public WAITInstruction(int code)
    {
        this();
        
        Operand codeOperand = getOperand("code");
        
        codeOperand.setIntegerValue(code);
    }
    
    @Override
    public void calculate(Processor processor)
    {
        // Do nothing.
    }
    
    @Override
    public void execute(Processor processor)
    {
        // Do nothing.
    }

    @Override
    public String toString()
    {
        Operand codeOperand = getOperand("code");
        
        return "wait 0x" + Integer.toHexString(codeOperand.getIntegerValue());
    }
    
    @Override
    public Instruction createInstruction()
    {
        return new WAITInstruction();
    }
}
