/* 
 * Copyright (c) 2009 ISPRAS
 *
 * Institute for System Programming of Russian Academy of Sciences
 * 25 B.Kommunisticheskaya st. Moscow 109004 Russia
 *
 * All rights reserved.
 * 
 * $Id: LoadImmediate32Program.java,v 1.1 2009/07/14 12:37:13 kamkin Exp $
 */

package com.unitesk.testfusion.demo.model.lib;

import com.unitesk.testfusion.core.model.Program;
import com.unitesk.testfusion.demo.model.DemoProcessor;
import com.unitesk.testfusion.demo.model.DemoRegister;
import com.unitesk.testfusion.demo.model.isa.logic.LUIInstruction;
import com.unitesk.testfusion.demo.model.isa.logic.ORIInstruction;

/**
 * @author <a href="mailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class LoadImmediate32Program extends Program
{
    public LoadImmediate32Program(DemoProcessor processor, DemoRegister rt, int immediate)
    {
    	int hi = immediate >>> 16;
    	int lo = immediate & 0xffff;
    	
    	if(hi != 0)
    	{
	        append(new LUIInstruction(rt, hi));
	        
	        if(lo != 0)
	            { append(new ORIInstruction(rt, rt, lo)); }
    	}
    	else
    		{ append(new ORIInstruction(rt, processor.getRegister(0), lo)); }
    }
}
